/*  
Name: BasicConditionals_2.java
Role: Teach you all about conditionals!

Author: Sam Vinitsky
Date: 6/25
*/
public class BasicConditionals_2{

    public static void main(String[] args){
        
        //////////////
        // TEACHING //
        //////////////

        // This is a conditional
        // if (true){
        //     System.out.println("It was true");
        // }

        // if (false){
        //     System.out.println("It was true");
        // }

        // if (5 < 10){
        //     System.out.println("It was true");
        // }


        // the expression inside gets evaluated
        boolean condition = false;
        // if (condition){
        //     System.out.println("It was true");
        // }


        // code before and after get run no matter what!
        // only the "body" of the if statement may be skipped
        // boolean raining = false;
        // System.out.println("Hello!");
        // if (raining){
        //     System.out.println("It is raining");
        //     System.out.println("I love the rain");
        // }
        // System.out.println("Goodbye!");

        // The thing in parenthesis gets **evaluated**
        // int temp = 50;
        // System.out.println("Hello!");
        // if (temp < 40){
        //     System.out.println("It is cold!");
        // }
        // System.out.println("Goodbye!");

        // The thing in parenthesis gets ***evaluated***
        // System.out.println("Hello!");
        // int temp = 10;
        // if (temp + 200 / temp == temp/2){  // must evaluate to a boolean
        //     System.out.println("It is cold!");
        // }
        // System.out.println("Goodbye!");

        ///////////////
        // QUESTIONS //
        ///////////////

        // ? - What if no braces?
        // if (false)
        //     System.out.println("Will I print?");
        //     System.out.println("Will I print too?");
        // System.out.println("Will I print three?");
        // USE BRACES!!!!!!!!!

        // ? - wrong type in parentheses?
        // if (6){
        //     System.out.println("huh?");
        // }
        
        /////////////
        // TRACING //
        /////////////

        // Trace:
        // int z = 11;
        // if (z + 2 > 9){
        //     System.out.println("It is true");
        // }
        // System.out.println("Hello!");

        // Trace (you): What will the following print? What about if x was 7?
        // int x = 7;  // 7
        // double d = 5.00;
        // if (x != d){
        //     System.out.println("x is not 7");
        // }
        // System.out.println("I'm happy.");

        ///////////////
        // QUESTIONS //
        ///////////////

        // ? - variable declared before, can we use inside?
        // int temp = 80;
        // if (temp > 60){
        //     System.out.println("Gosh, it's " + temp + " degrees out!");
        // }







        // ? - variable declared before, can we CHANGE it inside??
        // int temp = 80;
        // if (temp > 60){
        //     System.out.println("Gosh, it's " + temp + " degrees out!");
        //     temp = 0;
        // }
        // System.out.println(temp); // 60, 80, or 0?




        // ? - variable declared inside, can we use?
        // int temp = 80;
        // if (temp > 60) {
        //     System.out.println("Gosh, it's " + temp + " degrees out!");
        //     boolean hot = true;
        // }
        // System.out.println(hot);

        // {
        //     int x = 5;
        // }

        // System.out.println(x);

        // int x;
        // boolean c
        // if(c){
        //     x = 5;
        // }
        // if(c){
        //     x = 5;
        // }
        // System.out.println(x);






        /////////////
        // TRACING //
        /////////////

        // Trace (you)
        // int x = 10;
        // int y = 1;
        // if(x >= y){
        //     System.out.println("x is bigger: " + x);
        //     int z = 5;
        // } 
        
        // int z = 5;

        // System.out.println("Middle print");
        // if (y > x/2){
        //     System.out.println("But not by too much: " + y);
        // }


        // int x = -1;

        // if (askef){
        //     x = 5;
        // }




        /////////////
        // WRITING //
        /////////////

        // Write (you): if temp is less than 32 print "freezing", 
        // otherwise print "warm"
        // int temp;
        // temp = 33; // this might change!!!
        // // write some code here
        // if (temp < 32){
        //     System.out.println("freezing");
        // }
        // if (temp >= 32){
        //     System.out.println("warm");
        // }

        //////////
        // ELSE //
        //////////

        // // easier way:
        // int temp = 33;
        // if (temp < 32){
        //     // if the condition is TRUE, this runs
        //     System.out.println("freezing");
        // } else {
        //     // if the condition is FALSE, this runs
        //     System.out.println("warm");
        // }

        // if (h(5)){
        //     f(2);
        // } else{
        //     g(3)
        // }

        // Trace: (us)
        // int x = 10;
        // int y = 20;
        // System.out.println("Before");
        // if (x == y){
        //     System.out.println("They were the same!");
        // } else {
        //     System.out.println("They were different!!");
        // }
        // System.out.println("After");
        
        // Trace: (you)
        // double humidity = 0.78;
        // int temp = 100;
        // if (humidity * heat < 80){
        //     System.out.println("What a lovely day!");
        // } else {
        //     System.out.println("Brrr, I'm chilly!")
        // }

        // Write: (you)
        // int x = -2;
        // int y = 100;
        // // if x times y is positive, print "positive"
        // // otherwise print "negative"
    }
}
